var system = server.registerSystem(0, 0);

let last_command_output = null;
function commandCallback(results) {
    last_command_output = results;
};

function execute(command) {
    system.executeCommand(String(command), commandCallback);
};

function chat(text) {
    let execute = system.createEventData("minecraft:display_chat_event");
    execute.data.message = text;
    system.broadcastEvent("minecraft:display_chat_event", execute);
};

function chat_nearest_player(text, blockPos) {
    let cmd = "/tellraw @p[x=" + blockPos.x + ",y=" + blockPos.y + ",z=" + blockPos.z + "] " + `{"rawtext":[{"text":"` + text + `"}]}`
    execute(cmd)
}

system.initialize = function () {
    system.listenForEvent("minecraft:block_interacted_with", (eventData) => onBlockInteract(eventData));
    system.listenForEvent("minecraft:block_destruction_started", (eventData) => onBlockMine(eventData));
    system.listenForEvent("minecraft:player_destroyed_block", (eventData) => onBlockBreak(eventData));
    system.listenForEvent("minecraft:entity_sneak", (eventData) => onEntitySneak(eventData));
    system.listenForEvent("minecraft:player_attacked_entity", (eventData) => onPlayerAttack(eventData))

    system.listenForEvent("quarry:joined", onClientEnteredWorld)
};

let quarry_tracker = [];
let sneaking_players = [];

let last_seconds = new Date().getTime() / 1000

const getAllPropertyNames = function (obj) {
    const result = new Set(Object.getOwnPropertyNames(obj));
    while ((obj = Object.getPrototypeOf(obj)) !== null) {
        for (const value of Object.getOwnPropertyNames(obj))
            result.add(value);
    }
    return Array.from(result.keys());
};

function copyx(mainObj) {
    let objCopy = {}; // objCopy will store a copy of the mainObj
    let key;

    for (key in mainObj) {
        objCopy[key] = mainObj[key]; // copies each property to the objCopy object
    }
    return objCopy;
}




// let new_quarry = [
0  // lower_coords,          // lower x and z
1  // upper_coords,          // upper x and z
2  // 0.2,                   // delay per block break
3  // 2.0,                   // current delay for next block break
4  // lower_coords[0] + 1,   // current block x
5  // block_pos.y,           // current block y
6  // lower_coords[1] + 1,   // current block z,
7  // 0,                     // last x
8  // 0,                     // last y
9  // 0,                     // last z
10 // 1                      // first time?
11 // block_pos.y            // y height
12 // found_coords.x,        // first coord x
13 // found_coords.y,        // first coord y
14 // found_coords.z,        // first coord z
15 // 1,                     // x direction
16 // 1,                     // z direction
17 // JSApiObj,              // entity ID
18 // 1,                     // running?
19 // [0,0,0],               // item spawning coords
20 // null,                  // fuel entity
21 // this_fuel_source,      // fuel source
22 // this_fuel_efficiency,  // fuel efficiency
23 // this_fuel_efficiency,  // blocks mined until next fuel usage
// ]

let playerx = null;

system.update = function () {

    var seconds = new Date().getTime() / 1000

    var deltaTime = seconds - last_seconds
    last_seconds = seconds

    for (var i = 0; i < quarry_tracker.length; i++) {
        let objx = quarry_tracker[i];
        quarry_tracker[i][3] -= deltaTime;

        let lc = objx[0]
        let uc = objx[1]

        if (quarry_tracker[i][3] < 0.0) {
            quarry_tracker[i][3] = quarry_tracker[i][2]
            // chat("mine?")

            if (quarry_tracker[i][18]==1) {
                if (quarry_tracker[i][21]=='coal') {
                    let fuel_entity = quarry_tracker[i][20]
                    let fuel_entity_first_slot = system.getComponent(fuel_entity, "minecraft:inventory_container").data[0]
                    let fuel_entity_count = fuel_entity_first_slot.count
    
                    if (fuel_entity_first_slot.item != "minecraft:coal") {
                        return;
                    }
    
                    quarry_tracker[i][23] -= 1
                    if (quarry_tracker[i][23] <= 0) {
                        // chat("remove 1 coal?")
                        quarry_tracker[i][23] = quarry_tracker[i][22]
                        let fuel_entity_pos = system.getComponent(fuel_entity, "minecraft:position").data
                        // chat("got pos")
                        // chat(fuel_entity_count)
                        if (fuel_entity_count > 1) {
                            let cmd = ("/replaceitem entity @e[type=quarry:fuel,x="+fuel_entity_pos.x+",y="+fuel_entity_pos.y+",z="+fuel_entity_pos.z+",r=1,c=1] slot.inventory 0 coal "+(fuel_entity_count-1))
                            execute(cmd)
                            // chat(cmd)
                        } else {
                            let cmd = ("/replaceitem entity @e[type=quarry:fuel,x="+fuel_entity_pos.x+",y="+fuel_entity_pos.y+",z="+fuel_entity_pos.z+",r=1,c=1] slot.inventory 0 air 1")
                            execute(cmd)
                            // chat(cmd)
                        }
                        // chat("ran command...?")
                    }
                }
            }

            // chat("continue")




            execute("/fill " + objx[4] + " " + objx[5] + " " + objx[6] + " " + objx[4] + " " + objx[5] + " " + objx[6] + " air 0 destroy")

            let last_first = objx[10]

            if (objx[10] != 1) {
                execute("/tp @e[type=item,x=" + objx[4] + ",y=" + objx[5] + ",z=" + objx[6] + ",r=1.5] " + objx[19][0] + " " + (objx[19][1] + 2) + " " + objx[19][2])
            } else {
                objx[10] = 0
            }



            if (quarry_tracker[i][18] != 1) {
                let memory_entity_id = quarry_tracker[i][17]

                let tagComp = system.getComponent(memory_entity_id, "minecraft:tag")
                tagComp.data.splice(0, 1)
                tagComp.data.push(JSON.stringify(quarry_tracker[i]))
                system.applyComponentChanges(memory_entity_id, tagComp)

            } else {
                // chat("mine main...")

                quarry_tracker[i][7] = quarry_tracker[i][4] // x
                quarry_tracker[i][8] = quarry_tracker[i][5] // y
                quarry_tracker[i][9] = quarry_tracker[i][6] // z

                quarry_tracker[i][4] += quarry_tracker[i][15]

                let delete_this = false;

                if ((quarry_tracker[i][4] >= uc[0]) || (quarry_tracker[i][4] <= lc[0])) {
                    quarry_tracker[i][4] -= quarry_tracker[i][15]
                    if (quarry_tracker[i][15] < 0) { quarry_tracker[i][15] = 1 } else { quarry_tracker[i][15] = -1 }
                    quarry_tracker[i][6] += quarry_tracker[i][16]

                    if ((quarry_tracker[i][6] >= uc[1]) || (quarry_tracker[i][6] <= lc[1])) {
                        quarry_tracker[i][6] -= quarry_tracker[i][16]
                        if (quarry_tracker[i][16] < 0) { quarry_tracker[i][16] = 1 } else { quarry_tracker[i][16] = -1 }
                        quarry_tracker[i][5] -= 1
                        if (quarry_tracker[i][5] < 5) {
                            delete_this = true;
                        }
                    }
                }

                if (last_first) {
                    let upper_y_pos = quarry_tracker[i][11] + 6
                    let lower_y_pos = quarry_tracker[i][11]
                    let pos_x2 = quarry_tracker[i][0][0] + 1
                    let pos_z2 = quarry_tracker[i][0][1] + 1
                    execute("/fill " + pos_x2 + " " + lower_y_pos + " " + pos_z2 + " " + pos_x2 + " " + upper_y_pos + " " + pos_z2 + " air")

                    let post_start_y = quarry_tracker[i][11] + 1
                    let post_001_x = quarry_tracker[i][0][0]
                    let post_002_x = quarry_tracker[i][1][0]
                    let post_z = quarry_tracker[i][0][1] + 1
                    execute("/fill " + post_001_x + " " + post_start_y + " " + post_z + " " + post_001_x + " " + (post_start_y + 6) + " " + post_z + " air")
                    execute("/fill " + post_002_x + " " + post_start_y + " " + post_z + " " + post_002_x + " " + (post_start_y + 6) + " " + post_z + " air")
                    execute("/fill " + (post_001_x + 1) + " " + (post_start_y + 6) + " " + post_z + " " + (post_002_x - 1) + " " + (post_start_y + 6) + " " + post_z + " air")
                }

                let post_start_y = quarry_tracker[i][11] + 1
                let post_001_x = quarry_tracker[i][0][0]
                let post_002_x = quarry_tracker[i][1][0]
                let post_z_a = quarry_tracker[i][9]

                execute("/fill " + post_001_x + " " + post_start_y + " " + post_z_a + " " + post_001_x + " " + (post_start_y + 6) + " " + post_z_a + " air")
                execute("/fill " + post_002_x + " " + post_start_y + " " + post_z_a + " " + post_002_x + " " + (post_start_y + 6) + " " + post_z_a + " air")
                execute("/fill " + post_001_x + " " + (post_start_y + 6) + " " + post_z_a + " " + post_002_x + " " + (post_start_y + 6) + " " + post_z_a + " air")
                if (!delete_this) {
                    let post_z = quarry_tracker[i][6]
                    execute("/fill " + post_001_x + " " + post_start_y + " " + post_z + " " + post_001_x + " " + (post_start_y + 6) + " " + post_z + " rig_post")
                    execute("/fill " + post_002_x + " " + post_start_y + " " + post_z + " " + post_002_x + " " + (post_start_y + 6) + " " + post_z + " rig_post")
                    execute("/fill " + (post_001_x + 1) + " " + (post_start_y + 6) + " " + post_z + " " + (post_002_x - 1) + " " + (post_start_y + 6) + " " + post_z + " rig_top")
                }

                let upper_y_pos = quarry_tracker[i][11] + 6
                let lower_y_pos = quarry_tracker[i][8] + 1
                let pos_x = quarry_tracker[i][7]
                let pos_z = quarry_tracker[i][9]
                execute("/fill " + pos_x + " " + lower_y_pos + " " + pos_z + " " + pos_x + " " + upper_y_pos + " " + pos_z + " air")
                if (!delete_this) {
                    let lower_y_pos2 = quarry_tracker[i][5] + 1
                    let pos_x2 = quarry_tracker[i][4]
                    let pos_z2 = quarry_tracker[i][6]
                    execute("/fill " + pos_x2 + " " + lower_y_pos2 + " " + pos_z2 + " " + pos_x2 + " " + upper_y_pos + " " + pos_z2 + " rig_chain")
                }

                let memory_entity_id = quarry_tracker[i][17]

                let tagComp = system.getComponent(memory_entity_id, "minecraft:tag")
                tagComp.data.splice(0, 1)
                tagComp.data.push(JSON.stringify(quarry_tracker[i]))
                system.applyComponentChanges(memory_entity_id, tagComp)

                if (delete_this) {
                    let entity_id = objx[17]
                    let hpcomp = system.getComponent(entity_id, "minecraft:health")
                    hpcomp.data.value = -1
                    system.applyComponentChanges(entity_id, hpcomp)
                    if (quarry_tracker[i][21]=='coal') {
                        let fuel_entity = quarry_tracker[i][20]
                        let hpcomp = system.getComponent(fuel_entity, "minecraft:health")
                        hpcomp.data.value = -1
                        system.applyComponentChanges(fuel_entity, hpcomp)
                    }
                    quarry_tracker.splice(i, 1)
                }

                // chat("done mining block")
            }
        }
    }



    if (playerx != null) {
        chat(JSON.stringify(playerx))
    }


};

class blockPosC {
    constructor(x, y, z) {
        this.x = x
        this.y = y
        this.z = z
    }
}

class jsentity {
    constructor(identifier, type, id) {
        this.__identifier__ = identifier
        this.__type__ = type
        this.id = id
    }
}

let players_setting_positions = [];

let first_time_loaded_quarries = false;

function onClientEnteredWorld(parameters) {
    if (!first_time_loaded_quarries) {
        let quarry_query = system.registerQuery()
        let quarry_entities = system.getEntitiesFromQuery(quarry_query).filter(item => item.__identifier__ == "quarry:memory")
        chat("Quarries in world: "+quarry_entities.length)
        for (var ex in quarry_entities) {
            var ent = quarry_entities[ex]
            if (ent.__identifier__ == 'quarry:memory') {
                let tagComp = (system.getComponent(ent, "minecraft:tag"))
                let jsonQuarry = JSON.parse(tagComp.data[0])
                jsonQuarry[4]=jsonQuarry[7]
                jsonQuarry[5]=jsonQuarry[8]
                jsonQuarry[6]=jsonQuarry[9]
                quarry_tracker.push(jsonQuarry)
            }
        }
        first_time_loaded_quarries = true;
    }
}

let accepted_quarry_corners = [
    "quarry:corner_iron",
    "quarry:corner_gold",
    "quarry:corner_emerald",
    "quarry:corner_diamond",
    "quarry:corner_disidian"]
let quarry_mining_speeds = {
    "quarry:corner_iron": 0.75,
    "quarry:corner_gold": 0.6,
    "quarry:corner_emerald": 0.45,
    "quarry:corner_diamond": 0.35,
    "quarry:corner_disidian": 0.25
}
let max_size = {
    "quarry:corner_iron": 8,
    "quarry:corner_gold": 12,
    "quarry:corner_emerald": 20,
    "quarry:corner_diamond": 32,
    "quarry:corner_disidian": 64
}
let fuel_sources = {
    "quarry:corner_iron": "coal",
    "quarry:corner_gold": "coal",
    "quarry:corner_emerald": "coal",
    "quarry:corner_diamond": "solar",
    "quarry:corner_disidian": "none"
}
let fuel_efficiency = {
    "quarry:corner_iron": 16,
    "quarry:corner_gold": 24,
    "quarry:corner_emerald": 32,
    "quarry:corner_diamond": 0,
    "quarry:corner_disidian": 0
}

function onBlockInteract(eventData) {
    // chat("interact")

    let block_pos = eventData.data.block_position
    let playeri = eventData.data.player
    let handContainer = system.getComponent(playeri, "minecraft:hand_container");
    let mainhand = handContainer.data[0];
    let itemx = (mainhand.item);

    let blockJsAPI = system.getBlock(system.getComponent(playeri, "minecraft:tick_world").data.ticking_area, block_pos)
    let blockId = blockJsAPI.__identifier__

    if (itemx == "quarry:miner") {
        if (accepted_quarry_corners.includes(blockId)) {
            chat_nearest_player(
                "§6[Quarry]: First position set to [" + block_pos.x + ", " + block_pos.y + ", " + block_pos.z + "]",
                block_pos
            )
            let new_players_setting_positions = [playeri.id, block_pos, blockId];

            let pe = false;
            for (var i = 0; i < players_setting_positions.length; i++) {
                let objectx = players_setting_positions[i]
                if (playeri.id == objectx[0]) {
                    pe = true;
                    break
                }
            }

            if (pe) { players_setting_positions.splice(i, 1) }

            players_setting_positions.push(new_players_setting_positions);
        }
    }
};

function flatten(arr) {
    return arr.reduce(function (flat, toFlatten) {
        return flat.concat(Array.isArray(toFlatten) ? flatten(toFlatten) : toFlatten);
    }, []);
}

function onBlockMine(eventData) {
    let block_pos = eventData.data.block_position
    let playeri = eventData.data.player
    let handContainer = system.getComponent(playeri, "minecraft:hand_container")
    let mainhand = handContainer.data[0]
    let itemx = (mainhand.item)

    let blockJsAPI = system.getBlock(system.getComponent(playeri, "minecraft:tick_world").data.ticking_area, block_pos)
    let blockId = blockJsAPI.__identifier__

    let found_player = false
    let found_coords = null
    let require_corner = null
    for (var i = 0; i < players_setting_positions.length; i++) {
        let objectx = players_setting_positions[i]
        if (playeri.id == objectx[0]) {
            found_player = true
            found_coords = objectx[1]
            require_corner = objectx[2]
            break
        }
    }

    let this_max_size = max_size[blockId]

    if (itemx == "quarry:miner") {
        if ( accepted_quarry_corners.includes(blockId) ) {
            let this_quarry_speed = quarry_mining_speeds[blockId]
            if (found_player) {
                chat_nearest_player(
                    "§6[Quarry]: Second position set to [" + block_pos.x + ", " + block_pos.y + ", " + block_pos.z + "]",
                    block_pos
                )

                let qsize = [Math.abs(found_coords.x - block_pos.x), Math.abs(found_coords.y - block_pos.y), Math.abs(found_coords.z - block_pos.z)]

                let lower_coords = [Math.min(found_coords.x, block_pos.x), Math.min(found_coords.z, block_pos.z)]
                let upper_coords = [Math.max(found_coords.x, block_pos.x), Math.max(found_coords.z, block_pos.z)]

                let tc001 = [lower_coords[0], lower_coords[1]]
                let tc002 = [lower_coords[0], upper_coords[1]]
                let tc003 = [upper_coords[0], upper_coords[1]]
                let tc004 = [upper_coords[0], lower_coords[1]]
                let cornersx = [tc001, tc002, tc003, tc004]
                
                let collides = false;

                for (var qi = 0; qi<quarry_tracker.length; qi++) {
                    let tq = quarry_tracker[qi]
                    let lx = tq[0][0]
                    let lz = tq[0][1]
                    let ux = tq[1][0]
                    let uz = tq[1][1]
                    for (var ci = 0; ci < cornersx.length; ci++) {
                        let tc = cornersx[ci]
                        if (tc[0]>=lx & tc[0]<=ux) {
                            if (tc[1]>=lz & tc[1]<=uz) {
                                collides = true
                            }
                        }
                    }
                    if (collides) {
                        break
                    }
                }

                if (qsize[0]>(this_max_size+1) || qsize[2]>(this_max_size+1)) {
                    chat_nearest_player(
                        "§6[Quarry]: You've exceeded this quarry tier's maximum size. The max size for this tier is "+this_max_size+"x"+this_max_size,
                        block_pos
                    )
                    return
                }

                if (collides) {
                    chat_nearest_player(
                        "§6[Quarry]: This quarry collides with another existing quarry. Try removing the other one first",
                        block_pos
                    )
                    return
                }

                if (qsize[1] != 0) {
                    chat_nearest_player(
                        "§6[Quarry]: The first and second positions of the quarry should be at the same Y coordinate / height",
                        block_pos
                    )
                } else {
                    if (qsize[0] < (5 + 1) || qsize[2] < (5 + 1)) {
                        chat_nearest_player(
                            "§6[Quarry]: The quarry size must be at least 5x5 blocks",
                            block_pos
                        )
                    } else {

                        let pta = system.getComponent(playeri, "minecraft:tick_world").data.ticking_area

                        let edge_001 = system.getBlocks(
                            pta,
                            new blockPosC(lower_coords[0], block_pos.y, lower_coords[1] + 1),
                            new blockPosC(lower_coords[0], block_pos.y, upper_coords[1] - 1))
                        let edge_002 = system.getBlocks(
                            pta,
                            new blockPosC(lower_coords[0] + 1, block_pos.y, lower_coords[1]),
                            new blockPosC(upper_coords[0] - 1, block_pos.y, lower_coords[1]))
                        let edge_003 = system.getBlocks(
                            pta,
                            new blockPosC(upper_coords[0], block_pos.y, lower_coords[1] + 1),
                            new blockPosC(upper_coords[0], block_pos.y, upper_coords[1] - 1))
                        let edge_004 = system.getBlocks(
                            pta,
                            new blockPosC(lower_coords[0] + 1, block_pos.y, upper_coords[1]),
                            new blockPosC(upper_coords[0] - 1, block_pos.y, upper_coords[1]))

                        let fle001 = flatten(edge_001)
                        let fle002 = flatten(edge_002)
                        let fle003 = flatten(edge_003)
                        let fle004 = flatten(edge_004)

                        let alledge = fle001.concat(fle002.concat(fle003.concat(fle004)))

                        let hasNonEdge = false
                        for (var ix = 0; ix < alledge.length; ix++) {
                            var obx = alledge[ix]
                            if (obx.__identifier__ != 'quarry:edge') {
                                hasNonEdge = true
                                break
                            }
                        }

                        if (hasNonEdge) {
                            chat_nearest_player(
                                "§6[Quarry]: You must place four quarry corner blocks (of the same tier) and outline your quarry area with edge blocks",
                                block_pos
                            )
                        } else {

                            let corner001 = system.getBlock(pta, new blockPosC(lower_coords[0], block_pos.y, lower_coords[1])).__identifier__
                            let corner002 = system.getBlock(pta, new blockPosC(lower_coords[0], block_pos.y, upper_coords[1])).__identifier__
                            let corner003 = system.getBlock(pta, new blockPosC(upper_coords[0], block_pos.y, lower_coords[1])).__identifier__
                            let corner004 = system.getBlock(pta, new blockPosC(upper_coords[0], block_pos.y, upper_coords[1])).__identifier__

                            if ((corner001!=require_corner) || (corner002!=require_corner) || (corner003!=require_corner) || (corner004!=require_corner)) {
                                chat_nearest_player(
                                    "§6[Quarry]: Every corner of the quarry must have a corner block, and each corner block must be the same",
                                    block_pos
                                )
                            } else {

                                let this_fuel_source = fuel_sources[ blockId ]
                                let this_fuel_efficiency = fuel_efficiency[ blockId ]

                                let new_entity = system.createEntity('entity', 'quarry:memory')

                                let new_entity_fuel = null
                                if (this_fuel_source=='coal') {
                                    new_entity_fuel = system.createEntity('entity', 'quarry:fuel')
                                }

                                let new_quarry = [
                                    lower_coords,          // lower x and z
                                    upper_coords,          // upper x and z
                                    this_quarry_speed,     // delay per block break
                                    2.0,                   // current delay for next block break
                                    lower_coords[0] + 1,   // current block x
                                    block_pos.y,           // current block y
                                    lower_coords[1] + 1,   // current block z,
                                    0,                     // last x
                                    0,                     // last y
                                    0,                     // last z
                                    1,                     // first time?                - 10
                                    block_pos.y,           // y height
                                    found_coords.x,        // first coord x
                                    found_coords.y,        // first coord y
                                    found_coords.z,        // first coord z
                                    1,                     // x direction
                                    1,                     // z direction
                                    null,                  // entity
                                    1,                     // running?
                                    [0,0,0],               // item spawning coords
                                    null,                  // fuel entity
                                    this_fuel_source,      // fuel source
                                    this_fuel_efficiency,  // fuel efficiency
                                    this_fuel_efficiency,  // blocks mined until next fuel usage
                                ]

                                new_quarry[19][0] = found_coords.x
                                new_quarry[19][1] = found_coords.y
                                new_quarry[19][2] = found_coords.z

                                if (found_coords.x>block_pos.x) { new_quarry[19][0] += 1 } else { new_quarry[19][0] -= 1 }

                                new_quarry[7] = new_quarry[4]
                                new_quarry[8] = new_quarry[5]
                                new_quarry[9] = new_quarry[6]

                                let upper_y_pos = new_quarry[11] + 6
                                let lower_y_pos = new_quarry[5] + 1
                                let pos_x2 = new_quarry[4]
                                let pos_z2 = new_quarry[6]
                                execute("/fill " + pos_x2 + " " + lower_y_pos + " " + pos_z2 + " " + pos_x2 + " " + upper_y_pos + " " + pos_z2 + " rig_chain")

                                let post_start_y = new_quarry[11] + 1
                                let post_001_x = new_quarry[0][0]
                                let post_002_x = new_quarry[1][0]
                                let post_z = new_quarry[6]
                                execute("/fill " + post_001_x + " " + post_start_y + " " + post_z + " " + post_001_x + " " + (post_start_y + 6) + " " + post_z + " rig_post")
                                execute("/fill " + post_002_x + " " + post_start_y + " " + post_z + " " + post_002_x + " " + (post_start_y + 6) + " " + post_z + " rig_post")
                                execute("/fill " + (post_001_x + 1) + " " + (post_start_y + 6) + " " + post_z + " " + (post_002_x - 1) + " " + (post_start_y + 6) + " " + post_z + " rig_top")

                                let poscomp = system.getComponent(new_entity, "minecraft:position")
                                poscomp.data.x = block_pos.x + 0.5
                                poscomp.data.y = block_pos.y + 1
                                poscomp.data.z = block_pos.z + 0.5
                                system.applyComponentChanges(new_entity, poscomp)

                                new_quarry[17] = new_entity

                                if (new_entity_fuel!=null) {
                                    new_quarry[20] = new_entity_fuel
                                    let poscomp = system.getComponent(new_entity_fuel, "minecraft:position")
                                    poscomp.data.x = block_pos.x + 0.5
                                    poscomp.data.y = block_pos.y + 1 + 1
                                    poscomp.data.z = block_pos.z + 0.5
                                    system.applyComponentChanges(new_entity_fuel, poscomp)
                                }

                                let tagComp = system.createComponent(new_entity, "minecraft:tag")
                                tagComp.data.push(JSON.stringify(new_quarry))
                                system.applyComponentChanges(new_entity, tagComp)

                                quarry_tracker.push(new_quarry)

                                chat_nearest_player(
                                    "§6[Quarry]: Building new quarry from [" + found_coords.x + ", " + found_coords.y + ", " + found_coords.z + "] to [" + block_pos.x + ", " + block_pos.y + ", " + block_pos.z + "]...",
                                    block_pos
                                )
                            }
                        }
                    }
                }

            } else {
                chat_nearest_player(
                    "§6[Quarry]: Set your first position by right-clicking on a quarry corner with a quarry miner, and set your second position by left-clicking on a quarry corner with a quarry miner",
                    block_pos
                )
            }
        }
    } else {
    }
};

function onBlockBreak(eventData) {
    let id = eventData.data.block_identifier
    let block_pos = eventData.data.block_position

    if (accepted_quarry_corners.includes(id) || id == "quarry:edge") {
        for (var i = 0; i < quarry_tracker.length; i++) {
            let objx = quarry_tracker[i]
            let lxz = objx[0]
            let uxz = objx[1]
            let yh = objx[11]

            let destroy_this = false;

            if ((block_pos.x >= lxz[0]) & (block_pos.x <= uxz[0]) & (block_pos.z >= lxz[1]) & (block_pos.z <= uxz[1]) & block_pos.y == yh) {
                if ((block_pos.x == lxz[0] || block_pos.x == uxz[0]) || (block_pos.z == lxz[1] || block_pos.z == uxz[1])) {
                    if (block_pos.y == yh) {
                        destroy_this = true;
                    }
                }
            }

            if (destroy_this) {

                let entity_id = objx[17]
                let hpcomp = system.getComponent(entity_id, "minecraft:health")
                hpcomp.data.value = -1
                system.applyComponentChanges(entity_id, hpcomp)
                
                if (objx[21]=='coal') {
                    let fuel_entity = objx[20]
                    let hpcomp = system.getComponent(fuel_entity, "minecraft:health")
                    hpcomp.data.value = -1
                    system.applyComponentChanges(fuel_entity, hpcomp)
                }

                let post_start_y = quarry_tracker[i][11] + 1
                let post_001_x = quarry_tracker[i][0][0]
                let post_002_x = quarry_tracker[i][1][0]
                let post_z_a = quarry_tracker[i][9]
                execute("/fill " + post_001_x + " " + post_start_y + " " + post_z_a + " " + post_001_x + " " + (post_start_y + 6) + " " + post_z_a + " air")
                execute("/fill " + post_002_x + " " + post_start_y + " " + post_z_a + " " + post_002_x + " " + (post_start_y + 6) + " " + post_z_a + " air")
                execute("/fill " + post_001_x + " " + (post_start_y + 6) + " " + post_z_a + " " + post_002_x + " " + (post_start_y + 6) + " " + post_z_a + " air")

                execute("/fill " + (quarry_tracker[i][0][0]) + " " + post_start_y + " " + (quarry_tracker[i][0][1]+1) + " " + (quarry_tracker[i][1][0]) + " " + (post_start_y+6) + " " + (quarry_tracker[i][1][1]-1) + " air")

                let upper_y_pos = quarry_tracker[i][11] + 6
                let lower_y_pos = quarry_tracker[i][8] + 1
                let pos_x = quarry_tracker[i][7]
                let pos_z = quarry_tracker[i][9]
                execute("/fill " + pos_x + " " + lower_y_pos + " " + pos_z + " " + pos_x + " " + upper_y_pos + " " + pos_z + " air")
                let lower_y_pos2 = quarry_tracker[i][8] + 1
                let pos_x2 = quarry_tracker[i][4]
                let pos_z2 = quarry_tracker[i][6]
                execute("/fill " + pos_x2 + " " + lower_y_pos2 + " " + pos_z2 + " " + pos_x2 + " " + upper_y_pos + " " + pos_z2 + " air")

                quarry_tracker.splice(i, 1)
                chat_nearest_player(
                    "§6[Quarry]: Removed quarry from [" + lxz[0] + ", " + yh + ", " + lxz[1] + "] to [" + uxz[0] + ", " + yh + ", " + uxz[1] + "]",
                    block_pos
                )
                break
            }
        }
    }
}

function onPlayerAttack(eventData) {
    let player_id = eventData.data.player
    let entity_id = eventData.data.attacked_entity

    if (entity_id.__identifier__ == "quarry:memory") {

        for (var i = 0; i < quarry_tracker.length; i++) {
            let objx = quarry_tracker[i]

            let this_ent_pos = system.getComponent(objx[17], 'minecraft:position').data
            let hit_ent_pos = system.getComponent(entity_id, 'minecraft:position').data

            if (this_ent_pos.x == hit_ent_pos.x & this_ent_pos.y == hit_ent_pos.y & this_ent_pos.z == hit_ent_pos.z) {
                let hpcomp = system.getComponent(entity_id, "minecraft:health")
                hpcomp.data.value = 999
                system.applyComponentChanges(entity_id, hpcomp)
                let position = system.getComponent(player_id, "minecraft:position").data
                quarry_tracker[i][18] = (0 - quarry_tracker[i][18])
                if (quarry_tracker[i][18] == 1) {
                    chat_nearest_player(
                        "§6[Quarry]: This quarry has been resumed",
                        position
                    )
                } else {
                    chat_nearest_player(
                        "§6[Quarry]: This quarry has been paused",
                        position
                    )
                }
            }
        }
    }
}

function onEntitySneak(eventData) {
    let ent = eventData.data.entity;
    let sneaking = eventData.data.sneaking;
    let identifier = ent.__identifier__;
    if (identifier == 'minecraft:player') {
        if (sneaking) {
            sneaking_players.push(ent.id)

        } else {
            sneaking_players.splice(sneaking_players.indexOf(ent.id), 1)
        }
    }
}